﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Threading; // 다중 쓰레드 사용을 위한 네임스페이스

namespace ThreadEx2
{
    public partial class Form1 : Form
    {
        Thread th1, th2, th3;   // 쓰레드 3개 생성
        Boolean th1_Start, th2_Start, th3_Start;    // 쓰레드 시작 플래그
        int i = 0;
        int th_Count = 300;

        public Form1()
        {
            InitializeComponent();
        }

        // AA() 쓰레드
        private void AA()
        {
            try
            {
                String strTemp;
                while (th1_Start)
                {
                    lock (this)
                    {
                        i++;
                        strTemp = Convert.ToString(i);
                        sPrint("A " + strTemp);
                    }

                    if (i >= th_Count)
                    {
                        Reset_Ctrl();
                    }
                }
            }
            catch { }
        }


        // BB() 쓰레드
        private void BB()
        {
        
            try
            {
                String strTemp;
                while (th2_Start)
                {
                    lock (this)
                    {
                        i++;
                        strTemp = Convert.ToString(i);
                        sPrint("B " + strTemp);
                    }

                    if (i >= th_Count)
                    {
                        Reset_Ctrl();
                    }
                }
            }
            catch { }
        }


        // CC() 쓰레드
        private void CC()
        {

            try
            {
                String strTemp;
                while (th3_Start)
                {
                    lock (this)
                    {
                        i++;
                        strTemp = Convert.ToString(i);
                        sPrint("C " + strTemp);
                    }

                    if (i >= th_Count)
                    {
                        Reset_Ctrl();
                    }
                } 
            }
            catch { }
        }
        
        //  textBox1 에 내용을 출력하는 함수
        private void sPrint(string iMsg)
        {
            try
            {
                textBox1.AppendText(iMsg);
                textBox1.AppendText(Environment.NewLine);
            }
            catch { }
        } // end of sPrint()

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            th1_Start = false;
            if (!(th1 == null))
            {
                th1.Abort();
            }

            th2_Start = false;
            if (!(th2 == null))
            {
                th2.Abort();
            }

            th3_Start = false;
            if (!(th3 == null))
            {
                th3.Abort();
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            haebi();
            textBox2.Text = Convert.ToString(th_Count);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                i = 0;
                th_Count = Convert.ToInt32(textBox2.Text);
                textBox1.Clear();
                button1.Enabled = false;
                textBox2.Enabled = false;
                
                th1_Start = true;
                th1 = new Thread(new ThreadStart(AA));
                th1.Start(); 
                
                th2_Start = true;
                th2 = new Thread(new ThreadStart(BB));
                th2.Start();

                th3_Start = true;
                th3 = new Thread(new ThreadStart(CC));
                th3.Start();
                 
            }
            catch { }
        }

        private void Reset_Ctrl()
        {
            // 시작 버튼, 쓰레드 반복 횟수 입력 상자 활성화
            button1.Enabled = true;
            textBox2.Enabled = true;

            // 쓰레드 중지
            th1_Start = false;
            th2_Start = false;
            th3_Start = false;
        }

        private void haebi()
        {
            sPrint("");
            sPrint("제목 : 멀티쓰레드 연습");
            sPrint("작성일 : 2009-10-01");
            sPrint("작성자 : haebi");
            sPrint("");
            sPrint("http://haebi.kr");
            sPrint("");
        }
    }
}